
#include "unix.h"

typedef struct _Point {
    float x, y, z;
} Point;


Box( method, xaxis, yaxis, zaxis, center, lowerLeft, upperRight,
             clockwise, primitive )
int method;
float xaxis, yaxis, zaxis;
Point center, lowerLeft, upperRight;
char clockwise;
int primitive;
{
    FILE *fp;
    extern char *filename;

    fp = fopen( filename, "w" );

    if( !method ) {
        xaxis = fabs( lowerLeft.x - upperRight.x ) / 2.;
        yaxis = fabs( lowerLeft.y - upperRight.y ) / 2.;
        zaxis = fabs( lowerLeft.z - upperRight.z ) / 2.;
        center.x = lowerLeft.x + xaxis;
        center.y = lowerLeft.y + yaxis;
        center.z = lowerLeft.z + zaxis;
    }

    fprintf( fp, "8\t6\t24\n" );

    /* Print the Coordinates of the points */
    fprintf( fp, "%.2f %.2f %.2f\n", -xaxis + center.x, -yaxis + center.y, -zaxis + center.z );
    fprintf( fp, "%.2f %.2f %.2f\n", -xaxis + center.x, -yaxis + center.y,  zaxis + center.z );
    fprintf( fp, "%.2f %.2f %.2f\n", -xaxis + center.x,  yaxis + center.y, -zaxis + center.z );
    fprintf( fp, "%.2f %.2f %.2f\n", -xaxis + center.x,  yaxis + center.y,  zaxis + center.z );
    fprintf( fp, "%.2f %.2f %.2f\n",  xaxis + center.x, -yaxis + center.y, -zaxis + center.z );
    fprintf( fp, "%.2f %.2f %.2f\n",  xaxis + center.x, -yaxis + center.y,  zaxis + center.z );
    fprintf( fp, "%.2f %.2f %.2f\n",  xaxis + center.x,  yaxis + center.y, -zaxis + center.z );
    fprintf( fp, "%.2f %.2f %.2f\n",  xaxis + center.x,  yaxis + center.y,  zaxis + center.z );

    /* Print the Conectivity data of the points */
    if( clockwise ) {
        fprintf( fp, "4 1 3 4 2\n" );
        fprintf( fp, "4 2 4 8 6\n" );
        fprintf( fp, "4 4 3 7 8\n" );
        fprintf( fp, "4 3 1 5 7\n" );
        fprintf( fp, "4 1 2 6 5\n" );
        fprintf( fp, "4 6 8 7 5\n" );
    }
    else {    /* counterClockwise */
        fprintf( fp, "4 1 2 4 3\n" );
        fprintf( fp, "4 2 6 8 4\n" );
        fprintf( fp, "4 4 8 7 3\n" );
        fprintf( fp, "4 3 7 5 1\n" );
        fprintf( fp, "4 1 5 6 2\n" );
        fprintf( fp, "4 6 5 7 8\n" );
    }
    fclose( fp );
}
